<?php

/**
 * A trap is modelled as 1:1 to an ORM service.
 */
class Trap_Model extends BaseTrap_Model {
	static public $rewrite_columns = array(
		'matches_service' => array('host', 'service')
	);

	public function get_matches_service() {
		$set = ServicePool_Model::all()
			->reduce_by('host.name', $this->get_host(), '=')
			->reduce_by('description', $this->get_service(), '=');
		return (int)($set->it(array(), array(), 1, 0)->current() !== false);
	}

	/**
	 * change subservice state
	 */
	public function change_state($state)
	{
		/* Update the [traps] table (in db: subservices) */
		$this->set_state($state);
		$this->save();

		/* Find corresponding Service, if available */
		$service = ServicePool_Model::all()
			->reduce_by('host.name', $this->get_host(), '=')
			->reduce_by('description', $this->get_service(), '=')
			->one();

		/* Update service */
		if($service instanceof Service_Model) {
			$service->process_check_result($this->get_message(), $state);
		}
	}
}
