listview_renderer_extra_objects.trap_matchers = [
	function() {
		return $('<div id="filter-query-set-matcher"/>').append(
			$('<h2/>').text(_('Create trap matcher')),
			$('<p/>').text(_('A trap matcher maps a handler to an oid. You can use a full OID, you can use an asterisk as a wildcard, or you can use the string "fallback" to only run your matcher when there are no matching, non-fallback matchers.')),
			$('<form/>').attr('action', '#').attr('id', 'trap-upload-matcher').append(
				$('<label/>').attr('for', 'matcher_oid').text(_('Oid, partial oid, or \'fallback\'')),
				$('<input/>').attr('type', 'text').attr('name', 'matcher_oid').attr('id', 'matcher_oid'),
				$('<br/>'),
				$('<label/>').attr('for', 'matcher_handler').text(_('Handler')),
				$('<select/>').attr('name', 'matcher_handler').attr('id', 'matcher_handler').append(
					$('<option/>')
				),
				$('<br/>'),
				$('<input type="submit"/>').val('Create matcher'),
				$('<input type="hidden" value="" name="matcher_n"/>')
		));
	}
];

listview_renderer_extra_objects.trap_handlers = [
	function() {
		return $('<div id="filter-query-upload-handler"/>').append(
			$('<h2/>').text(_('Upload trap handler')),
			$('<p/>').text(_('This lets you install new trap handlers. You need to also install a matcher for the handler to trigger.')),
			$('<form/>').attr('action', '#').attr('id', 'trap-upload-handler').append(
				$('<label for="handler_name"/>').text(_('Name of handler')),
				$('<input type="text" name="handler_name" id="handler_name"/>'),
				$('<br/>'),
				$('<label/>').attr('for', 'handler_file').text(_('Select file')),
				$('<input/>').attr('type', 'file').attr('name', 'handler_file').attr('id', 'handler_file'),
				$('<br/>'),
				$('<input/>').attr('type', 'submit').val('Upload handler'),
				$('<input type="hidden" value="" name="handler_id"/>')
		));
	}
];

listview_renderer_extra_objects.trap_modules = [
	function() {
		return $('<div id="filter-query-upload-module"/>').append(
			$('<h2/>').text(_('Upload trap module')),
			$('<p/>').text(_('This lets you install new trap modules. A module can contain extra data definitions, and can be included in handlers.')),
			$('<form/>').attr('action', '#').attr('id', 'trap-upload-module').append(
				$('<label for="module_name"/>').text(_('Name of module')),
				$('<input type="text" name="module_name" id="module_name"/>'),
				$('<br/>'),
				$('<label/>').attr('for', 'module_file').text(_('Select file')),
				$('<input/>').attr('type', 'file').attr('name', 'module_file').attr('id', 'module_file'),
				$('<br/>'),
				$('<input/>').attr('type', 'submit').val('Upload module'),
				$('<input type="hidden" value="" name="module_id"/>')
		));
	}
];

listview_renderer_extra_objects.traps = [
	function() {
		var obj = $('<div id="filter-query-send-trap"/>').append(
			$('<h2/>').text(_('Send trap manually')),
			$('<p/>').text(_('Generate a custom trap, for test purposes')),
			$('<form/>').attr('action', '#').attr('id', 'trap-send-trap').append(
				$('<label for="trap-version-selector"/>').text(_("Generate trap version")),
				$('<select id="trap-version-selector" name="trap-version-selector"/>').append(
					$('<option value="v1"/>').text(_('1')),
					$('<option value="v2c" selected="selected"/>').text(_('2c/3'))
				),
				$('<fieldset id="v1" style="display:none"/>').append(
					$('<legend/>').text(_('Version 1 trap')),
					$('<label/>').attr('for', 'v1-enterprise-oid').text(_('Enterprise OID')),
					$('<input/>').attr('type', 'text').attr('name', 'v1-enterprise-oid').attr('id', 'v1-enterprise-oid'),
					$('<br/>'),
					$('<label/>').attr('for', 'v1-agent').text(_('Agent')),
					$('<input/>').attr('type', 'text').attr('name', 'v1-agent').attr('id', 'v1-agent').val('localhost'),
					$('<br/>'),
					$('<label/>').attr('for', 'v1-generic-trap').text(_('Generic trap')),
					$('<input/>').attr('type', 'text').attr('name', 'v1-generic-trap').attr('id', 'v1-generic-trap'),
					$('<br/>'),
					$('<label/>').attr('for', 'v1-specific-trap').text(_('Specific trap')),
					$('<input/>').attr('type', 'text').attr('name', 'v1-specific-trap').attr('id', 'v1-specific-trap'),
					$('<br/>'),
					$('<label/>').attr('for', 'v1-uptime').text(_('Uptime')),
					$('<input/>').attr('type', 'text').attr('name', 'v1-uptime').attr('id', 'v1-uptime'),
					$('<br/>')
				),
				$('<fieldset id="v2c"/>').append(
					$('<legend/>').text(_('Version 2c/3 trap')),
					$('<label/>').attr('for', 'v2-uptime').text(_('Uptime')),
					$('<input/>').attr('type', 'text').attr('name', 'v2-uptime').attr('id', 'v2-uptime'),
					$('<br/>'),
					$('<label/>').attr('for', 'v2-trap-oid').text(_('Trap OID')),
					$('<input/>').attr('type', 'text').attr('name', 'v2-trap-oid').attr('id', 'v2-trap-oid'),
					$('<br/>')
				),
				$('<fieldset/>').append(
					$('<legend/>').text(_('Trap contents')),
					$('<div id="trap-content"/>').append(
						$('<div/>').attr('class', 'line-template').append(
							$('<label/>').attr('for', 'oid').text(_('OID')),
							$('<input/>').attr('type', 'text').attr('name', 'oid').attr('id', 'oid'),
							$('<label/>').attr('for', 'type').text(_('Type')),
							$('<select/>').attr('name', 'type').attr('id', 'type').append(
								$('<option/>').val('i').text(_('Integer')),
								$('<option/>').val('u').text(_('Unsigned')),
								$('<option/>').val('c').text(_('Counter32')),
								$('<option/>').val('s').text(_('String')),
								$('<option/>').val('x').text(_('Hex String')),
								$('<option/>').val('d').text(_('Decimal String')),
								$('<option/>').val('n').text(_('Null Object')),
								$('<option/>').val('o').text(_('Object ID')),
								$('<option/>').val('t').text(_('Timeticks')),
								$('<option/>').val('a').text(_('IP Address')),
								$('<option/>').val('b').text(_('Bits'))),
							$('<label/>').attr('for', 'value').text(_('Value')),
							$('<input/>').attr('type', 'text').attr('name', 'value').attr('id', 'value'),
							$('<a/>').attr('href', '#').attr('class', 'trap-delete').append(
								$('<span/>').attr('class', 'icon-16 x16-remove')
							),
							$('<br/>')
						)
					),
					$('<a/>').attr('href', '#').attr('class', 'trap-add').append(
						$('<span/>').attr('class', 'icon-16 x16-command'),
						_("Add field")
					),
					$('<br/>'),
					$('<input/>').attr('type', 'submit').attr('value', 'Send trap'))),
			$('<pre class="command-line"/>'));
		Trapper.custom_template_setup(obj);
		return obj;
	}
];
