<?php

$tables = array (
	'traps' =>
	array(
		'class' => 'Trap',
		'source' => 'MySQL',
		'table' => 'subservices',
		'db_instance' => 'trapper',
		'key' => array('time', 'host', 'service', 'tag'),
		'writable' => true,
		'default_sort' => array('time desc'),
		'structure' => array(
			'host' => 'string',
			'service' => 'string',
			'tag' => 'string',
			'state' => 'int',
			'message' => 'string',
			'count' => 'int',
			'trapoid' => 'string',
			'trap' => 'string',
			'time' => 'string',
		),
	),
	'trap_handlers' =>
	array(
		'class' => 'TrapHandler',
		'source' => 'MySQL',
		'table' => 'handlers',
		'db_instance' => 'trapper',
		'key' => array('id'),
		'writable' => true,
		'default_sort' => array('name'),
		'structure' => array(
			'id' => 'int',
			'name' => 'string',
			'script' => 'string',
			'context' => 'string', # Serialized lua - how hard is it to show sanely?
		),
	),
	'trap_logs' =>
	array(
		'class' => 'TrapLog',
		'source' => 'MySQL',
		'table' => 'logs',
		'db_instance' => 'trapper',
		'key' => array('id'),
		'writable' => true,
		'default_sort' => array('time desc'),
		'structure' => array(
			'id' => 'int',
			'time' => 'string',
			'handler' => 'string',
			'message' => 'string',
		),
	),
	'trap_matchers' =>
	array(
		'class' => 'TrapMatcher',
		'source' => 'MySQL',
		'table' => 'matches',
		'db_instance' => 'trapper',
		'key' => array('n'),
		'writable' => true,
		'default_sort' => array('n'),
		'relations' => array(
			array(array('handler_id'), 'trap_handlers', 'handlers'),
		),
		'structure' => array(
			'n' => 'string',
			'oid' => 'string',
			'handler_id' => 'int',
			'handlers' => array('TrapHandler', 'handlers.'),
		),
	),
	'trap_modules' =>
	array(
		'class' => 'TrapModule',
		'source' => 'MySQL',
		'table' => 'modules',
		'db_instance' => 'trapper',
		'key' => array('id'),
		'writable' => true,
		'default_sort' => array('name'),
		'structure' => array(
			'id' => 'int',
			'name' => 'string',
			'script' => 'string',
		),
	),
);
